HDU6356 Glad You Came(2018HDU多校联赛第五场,线段树)

2023-10-05 23:00

本文主要是介绍HDU6356 Glad You Came(2018HDU多校联赛第五场,线段树),希望对大家解决编程问题提供一定的参考价值,需要的开发者们随着小编来一起学习吧!

Problem Description

Steve has an integer array a of length n (1-based). He assigned all the elements as zero at the beginning. After that, he made m operations, each of which is to update an interval of a with some value. You need to figure out ⨁ni=1(i⋅ai) after all his operations are finished, where ⨁ means the bitwise exclusive-OR operator.
In order to avoid huge input data, these operations are encrypted through some particular approach.
There are three unsigned 32-bit integers X,Y and Z which have initial values given by the input. A random number generator function is described as following, where ∧ means the bitwise exclusive-OR operator, << means the bitwise left shift operator and >> means the bitwise right shift operator. Note that function would change the values of X,Y and Z after calling.
img

Let the i-th result value of calling the above function as (i=1,2,,3m) ( i = 1 , 2 , ⋯ , 3 m ) The i-th operation of Steve is to update aj as vi if (j=li,li+1,,ri) ( j = l i , l i + 1 , ⋯ , r i ) , where

lirivi=min((f3i2modn)+1,(f3i1modn)+1)=max((f3i2modn)+1,(f3i1modn)+1)=f3imod230(i=1,2,,m). { l i = min ( ( f 3 i − 2 mod n ) + 1 , ( f 3 i − 1 mod n ) + 1 ) r i = max ( ( f 3 i − 2 mod n ) + 1 , ( f 3 i − 1 mod n ) + 1 ) v i = f 3 i mod 2 30 ( i = 1 , 2 , ⋯ , m ) .

Input

The first line contains one integer T, indicating the number of test cases.
Each of the following T lines describes a test case and contains five space-separated integers n,m,X,Y and Z.
1≤T≤100, 1≤n≤105, 1≤m≤5⋅106, 0≤X,Y,Z<230.
It is guaranteed that the sum of n in all the test cases does not exceed 106 and the sum of m in all the test cases does not exceed 5⋅107.

Output

For each test case, output the answer in one line.

Sample Input

4
1 10 100 1000 10000
10 100 1000 10000 100000
100 1000 10000 100000 1000000
1000 10000 100000 1000000 10000000

Sample Output

1031463378
1446334207
351511856
47320301347

Hint

In the first sample, a = [1031463378] after all the operations. In the second sample, a = [1036205629, 1064909195, 1044643689, 1062944339, 1062944339, 1062944339, 1062944339, 1057472915, 1057472915, 1030626924] after all the operations.

思路

题目给你了一个 n,m,x,y,z n , m , x , y , z ,还给了一个生成函数由给出的 x,y,z x , y , z ,可以生成不同的值。

刚开始有长度为 n n 全部为0的序列,然后有m个操作,每个操作有 l,r,v l , r , v ,代表把区间 [l,r] [ l , r ] 内小于 v v 的数变成v l,r,v l , r , v 可以由给出的函数生成。注意这个函数里面的类型是unsigned int
最后询问i^a[i]的和

直接用线段树尽心更新就好,这个题主要是题难读懂。。

代码

#include <bits/stdc++.h>
using namespace std;
#define mem(a, b) memset(a, b, sizeof(a))
#define lson l, m, rt << 1
#define rson m + 1, r, rt << 1 | 1
typedef long long ll;
typedef unsigned int uint;
const int N = 1e5 + 100;
uint x, y, z;
uint calc()
{x = x ^ (x << 11);x = x ^ (x >> 4);x = x ^ (x << 5);x = x ^ (x >> 14);uint w = x ^ (y ^ z);x = y;y = z;z = w;return z;
}
int MAX[N << 2];
void pushup(int rt)
{MAX[rt] = max(MAX[rt << 1], MAX[rt << 1 | 1]);
}
void pushdown(int rt)
{if (MAX[rt]){MAX[rt << 1] = max(MAX[rt << 1], MAX[rt]);MAX[rt << 1 | 1] = max(MAX[rt << 1 | 1], MAX[rt]);}
}
void build(int l, int r, int rt)
{MAX[rt] = 0;if (l == r)return;int m = (l + r) >> 1;build(lson);build(rson);pushup(rt);
}void update(int L, int R, int v, int l, int r, int rt)
{if (v <= MAX[rt])return;if (L <= l && r <= R){MAX[rt] = v;return;}pushdown(rt);int m = (l + r) >> 1;if (L <= m)update(L, R, v, lson);if (R > m)update(L, R, v, rson);
}
int query(int p, int l, int r, int rt)
{if (l == r)return MAX[rt];pushdown(rt);int m = (l + r) >> 1;if (p <= m)return query(p, lson);elsereturn query(p, rson);
}
void solve()
{int n, m;int mod = 1 << 30;scanf("%d%d%u%u%u", &n, &m, &x, &y, &z);build(1, n, 1);while (m--){uint p = calc();uint q = calc();int l = min(p % n + 1, q % n + 1);int r = max(p % n + 1, q % n + 1);int v = calc() % mod;if (l > r)swap(l, r);update(l, r, v, 1, n, 1);}ll ans = 0;for (int i = 1; i <= n; i++)ans = ans ^ (1ll * i * query(i, 1, n, 1));printf("%lld\n", ans);
}
int main()
{//freopen("in.txt","r",stdin);int t;scanf("%d", &t);while (t--)solve();return 0;
}

这篇关于HDU6356 Glad You Came(2018HDU多校联赛第五场,线段树)的文章就介绍到这儿,希望我们推荐的文章对编程师们有所帮助!



http://www.chinasem.cn/article/152230

相关文章

poj3468(线段树成段更新模板题)

题意:包括两个操作:1、将[a.b]上的数字加上v;2、查询区间[a,b]上的和 下面的介绍是下解题思路: 首先介绍  lazy-tag思想:用一个变量记录每一个线段树节点的变化值,当这部分线段的一致性被破坏我们就将这个变化值传递给子区间,大大增加了线段树的效率。 比如现在需要对[a,b]区间值进行加c操作,那么就从根节点[1,n]开始调用update函数进行操作,如果刚好执行到一个子节点,

hdu1394(线段树点更新的应用)

题意:求一个序列经过一定的操作得到的序列的最小逆序数 这题会用到逆序数的一个性质,在0到n-1这些数字组成的乱序排列,将第一个数字A移到最后一位,得到的逆序数为res-a+(n-a-1) 知道上面的知识点后,可以用暴力来解 代码如下: #include<iostream>#include<algorithm>#include<cstring>#include<stack>#in

hdu1689(线段树成段更新)

两种操作:1、set区间[a,b]上数字为v;2、查询[ 1 , n ]上的sum 代码如下: #include<iostream>#include<algorithm>#include<cstring>#include<stack>#include<queue>#include<set>#include<map>#include<stdio.h>#include<stdl

hdu 1754 I Hate It(线段树,单点更新,区间最值)

题意是求一个线段中的最大数。 线段树的模板题,试用了一下交大的模板。效率有点略低。 代码: #include <stdio.h>#include <string.h>#define TREE_SIZE (1 << (20))//const int TREE_SIZE = 200000 + 10;int max(int a, int b){return a > b ? a :

hdu 1166 敌兵布阵(树状数组 or 线段树)

题意是求一个线段的和,在线段上可以进行加减的修改。 树状数组的模板题。 代码: #include <stdio.h>#include <string.h>const int maxn = 50000 + 1;int c[maxn];int n;int lowbit(int x){return x & -x;}void add(int x, int num){while

poj 1127 线段相交的判定

题意: 有n根木棍,每根的端点坐标分别是 px, py, qx, qy。 判断每对木棍是否相连,当他们之间有公共点时,就认为他们相连。 并且通过相连的木棍相连的木棍也是相连的。 解析: 线段相交的判定。 首先,模板中的线段相交是不判端点的,所以要加一个端点在直线上的判定; 然后,端点在直线上的判定这个函数是不判定两个端点是同一个端点的情况的,所以要加是否端点相等的判断。 最后

HDU4737线段树

题目大意:给定一系列数,F(i,j)表示对从ai到aj连续求或运算,(i<=j)求F(i,j)<=m的总数。 const int Max_N = 100008 ;int sum[Max_N<<2] , x[Max_N] ;int n , m ;void push_up(int t){sum[t] = sum[t<<1] | sum[t<<1|1] ;}void upd

zoj 1721 判断2条线段(完全)相交

给出起点,终点,与一些障碍线段。 求起点到终点的最短路。 枚举2点的距离,然后最短路。 2点可达条件:没有线段与这2点所构成的线段(完全)相交。 const double eps = 1e-8 ;double add(double x , double y){if(fabs(x+y) < eps*(fabs(x) + fabs(y))) return 0 ;return x + y ;

圆与线段的交点

poj 3819  给出一条线段的两个端点,再给出n个圆,求出这条线段被所有圆覆盖的部分占了整条线段的百分比。 圆与线段的交点 : 向量AB 的参数方程  P = A + t * (B - A)      0<=t<=1 ; 将点带入圆的方程即可。  注意: 有交点 0 <= t <= 1 ; 此题求覆盖的部分。 则 若求得 t  满足 ; double ask(d

Codeforces 482B 线段树

求是否存在这样的n个数; m次操作,每次操作就是三个数 l ,r,val          a[l] & a[l+1] &......&a[r] = val 就是区间l---r上的与的值为val 。 也就是意味着区间[L , R] 每个数要执行 | val 操作  最后判断  a[l] & a[l+1] &......&a[r] 是否= val import ja